from django.shortcuts import render
from seller.models import ProductData as sellerproducts
from kisan.models import ProductData as kisanproducts , link_mf_product
from accounts.models import UserData, SellerData, KisanData
from django.views.decorators.csrf import csrf_exempt
from django.db.models import Q


# Create your views here.
# def search(request):
#     query = request.GET.get('q', None)
#     x = ProductData.objects.none()
#     if query is not None:
#         lookups = Q(p_name__icontains=query) | Q(p_desc__icontains=query)
#         x = ProductData.objects.filter(lookups).distinct()
#         return render(request, 'search/search-display.html', {'prods': x, 'tot': len(x)})
#     return render(request, 'search/search-display.html', {'prods': x, 'tot': len(x)})
#

from functools import reduce
from django.contrib.auth.models import User

def search(request):
    query = request.GET.get('q', None)
    query = query.strip()
    city_loc = request.GET.get('city', None)
    user_pin = ''
    lst = []
    mf_prod = link_mf_product.objects.filter(p_city__icontains=city_loc, product__p_name__icontains=query).select_related()
    for obj in mf_prod:
        print(obj.product_id, obj.product, obj.product.p_name)
    if request.user.is_authenticated and (len(city_loc) == 0 or city_loc.isspace()):
        user = request.user.username
        if User.last_name == 1:
            user_pin = UserData.objects.get(email__iexact=user).pincode
        elif User.last_name == 2:
            user_pin = KisanData.objects.get(mobile__iexact=user).pincode
        elif User.last_name == 0:
            user_pin = SellerData.objects.get(email__iexact=user).pincode
        k_lst = KisanData.objects.filter(pincode__iexact=user_pin)
        K_lst = [i.mobile for i in k_lst]
        s_lst = SellerData.objects.filter(pincode__iexact=user_pin)
        S_lst = [i.email for i in s_lst]
        # if len(K_lst)>0:
        #     k = reduce(lambda x, y: x | y, [Q(s_username__icontains=i) for i in K_lst])
        # else: k = ('','')
        # if len(S_lst)>0:
        #     s = reduce(lambda x, y: x | y, [Q(s_username__icontains=i) for i in S_lst])
        # else: s = ('','')
        if len(query) != 0 and not query.isspace():
            if len(K_lst) > 0:
                k = reduce(lambda x, y: x | y, [Q(s_username__icontains=i) for i in K_lst])
                lookups = Q(p_name__icontains=query) | Q(p_desc__icontains=query) & k
                x = kisanproducts.objects.filter(lookups).distinct()
            else:   x = ''
            if len(S_lst) > 0:
                s = reduce(lambda x, y: x | y, [Q(s_username__icontains=i) for i in S_lst])
                lookups = Q(p_name__icontains=query) | Q(p_desc__icontains=query) & s
                y = sellerproducts.objects.filter(lookups).distinct()
            else:   y = ''
            return render(request, 'search/search-display.html', {'prods': x, 'tot': len(x),
                                                                  'sprods': y, 'stot': len(y),
                                                                  'mf_prod':mf_prod, 'mtot': len(mf_prod) })
    elif request.user.is_authenticated and city_loc == 'All India':
        if len(query) != 0 and not query.isspace():
            lookups = Q(p_name__icontains=query) | Q(p_desc__icontains=query)
            x = kisanproducts.objects.filter(lookups).distinct()
            y = sellerproducts.objects.filter(lookups).distinct()
            return render(request, 'search/search-display.html', {'prods': x, 'tot': len(x),
                                                                  'sprods': y, 'stot': len(y),
                                                                  'mf_prod': mf_prod, 'mtot': len(mf_prod)})
    elif request.user.is_anonymous and (city_loc == 'All India' or len(city_loc) == 0):
        if len(query) != 0 and not query.isspace():
            lookups = Q(p_name__icontains=query) | Q(p_desc__icontains=query)
            x = kisanproducts.objects.filter(lookups).distinct()
            y = sellerproducts.objects.filter(lookups).distinct()
            return render(request, 'search/search-display.html', {'prods': x, 'tot': len(x),
                                                                  'sprods': y, 'stot': len(y),
                                                                  'mf_prod': mf_prod, 'mtot': len(mf_prod)})
    elif len(city_loc) > 0:
        k_lookups = Q(address__icontains=city_loc) | Q(city__icontains=city_loc) | Q(state__icontains=city_loc)
        s_lookups = Q(address__icontains=city_loc) | Q(state__icontains=city_loc)
        k_lst = KisanData.objects.filter(k_lookups).distinct()
        K_lst = [i.mobile for i in k_lst]
        s_lst = SellerData.objects.filter(s_lookups).distinct()
        S_lst = [i.email for i in s_lst]
        if len(query) != 0 and not query.isspace():
            if len(K_lst) > 0:
                k = reduce(lambda x, y: x | y, [Q(s_username__icontains=i) for i in K_lst])
                lookups = Q(p_name__icontains=query) | Q(p_desc__icontains=query) & k
                x = kisanproducts.objects.filter(lookups).distinct()
            else:   x = ''
            if len(S_lst) > 0:
                s = reduce(lambda x, y: x | y, [Q(s_username__icontains=i) for i in S_lst])
                lookups = Q(p_name__icontains=query) | Q(p_desc__icontains=query) & s
                y = sellerproducts.objects.filter(lookups).distinct()
            else:   y = ''
            return render(request, 'search/search-display.html', {'prods': x, 'tot': len(x),
                                                                  'sprods': y, 'stot': len(y),
                                                                  'mf_prod': mf_prod, 'mtot': len(mf_prod)})

    x = kisanproducts.objects.none()
    # if request.user.is_anonymous:
    #     if len(query) != 0 and not query.isspace():
    #         lookups = Q(p_name__icontains=query) | Q(p_desc__icontains=query)
    #         print(lookups)
    #         x = kisanproducts.objects.filter(reduce(q1,q2),lookups).distinct()
    #         y = sellerproducts.objects.filter(reduce(q1,q2),lookups).distinct()
    #         return render(request, 'search/search-display.html', {'prods': x, 'tot': len(x),
    #                                                               'sprods': y, 'stot': len(y)})
    # elif int(request.user.last_name) == 2:
    #     if len(query) != 0 and not query.isspace():
    #         lookups = Q(p_name__icontains=query) | Q(p_desc__icontains=query)
    #         x = kisanproducts.objects.filter(lookups).distinct()
    #         y = sellerproducts.objects.filter(lookups).distinct()
    #         return render(request, 'search/search-display.html', {'prods': x, 'tot': len(x),
    #                                                               'sprods': y, 'stot': len(y)})
    # # elif int(request.user.last_name) == 0:
    #     if len(query) != 0 and not query.isspace():
    #         lookups = Q(p_name__icontains=query) | Q(p_desc__icontains=query)
    #         x = kisanproducts.objects.filter(lookups).distinct()
    #         y = sellerproducts.objects.filter(lookups).distinct()
    #         return render(request, 'search/search-display.html', {'prods': x, 'tot': len(x),
    #                                                               'sprods': y, 'stot': len(y)})
    return render(request, 'search/search-display.html', {'prods': x, 'tot': len(x)})
